#ifndef __XTP_RENDER_H
#define __XTP_RENDER_H

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "xmms/plugin.h"

//
// Three types of terrain are:
//  CANYON - Left and right channels are displayed with
//           the outside being the lower frequencies and 
//           the inside being higher frequencies.
//  RIDGE  - Left and right channels are displayed with
//           the outside being the higher frequencies and 
//           the inside being lower frequencies.
//  SLOPE  - Only left channel is displayed, with high
//           frequencies at the right and low frequencies
//           at the left
//
typedef enum { CANYON, RIDGE, SLOPE } TerrainType;



//
// Initializes memory for the height field, as well as
// setting up SDL and OpenGL
//
void TerrainInit();

//
// Checks for errors and draws a frame of the terrain
//
void TerrainRender();

//
// Adds a row to the heightfield
// Parameters are the left and right channels of data
//
void UpdateHeightField(gint16 *l, gint16 *r);

//
// Frees memory for height field and destroys
// SDL context
//
void TerrainDestroy();



#endif
