#include <stdlib.h>
#include "xmms/plugin.h"
#include "xmms/util.h"
#include "render.h"
#include "prefs_dialog.h"

/*
 * Basically just a wrapper for the calls in 
 * render.c
 */


static void xtp_init(void);
static void xtp_cleanup(void);
static void xtp_about(void);
static void xtp_configure(void);
static void xtp_render_freq(gint16 data[2][256]);


VisPlugin xtp_vp =
{
	NULL,
	NULL,
	0,
	"OpenGL Terrain Plugin 0.12",
	0,
	256,		
	xtp_init, /* init */
	xtp_cleanup, /* cleanup */
	xtp_about, /* about */
	xtp_configure, /* configure */
	NULL, /* disable_plugin */
	NULL, /* playback_start */
	NULL, /* playback_stop */
	NULL, /* render_pcm */
	xtp_render_freq  /* render_freq */
};


VisPlugin *get_vplugin_info(void)
{
  return &xtp_vp;
}


static void xtp_init(void)
{
  TerrainInit();
}

static void xtp_cleanup(void)
{
  TerrainDestroy();
}


static void xtp_about(void)
{
  GtkWidget *dialog;
  dialog = xmms_show_message("About libxtp", "OpenGL Terrain Plugin 0.11"
			     "\nDraws terrain based on the music\n"
			     "you are listening to.\n\n"
			     "by Keith Ito <keithito@stanford.edu>", 
			     "Close", FALSE, NULL, NULL);
  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
		     GTK_SIGNAL_FUNC(gtk_widget_destroyed),
		     &dialog);
}


static void xtp_configure(void)
{
  GtkWidget *dialog;
  dialog = xtp_create_prefs_dialog();
  if (dialog) {
    gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
		       GTK_SIGNAL_FUNC(gtk_widget_destroyed),
		       &dialog);
    gtk_widget_show(dialog);
  }
}


static void xtp_render_freq(gint16 data[2][256])
{
  UpdateHeightField(data[0], data[1]);
  TerrainRender();
}


